/**

 * @author v_wangyan

 * @date 2012-11-05

 */ 

var skin = window.skin || {};



//fixed by shichunhua, make sure server sign code in correct.

var serverSignCode = null;



/**

 * 获取元素对象

 * @param  {string} element 元素id

 * @return {object}         返回元素对象

 */

skin.g = function(element) {

    return document.getElementById(element) || element;

},

/**

 * 转换JSON对象

 * @param  {string} jsonString json字符串

 * @return {object}            json对象

 */

skin.jsonDecode =function(jsonString) {

	return (new Function("return " + jsonString))();

},

skin.encodeHTML = function () {



},

/**

 * 显示dom

 * @param  {string} id dom的id

 * @return {void}    无

 */

skin.show = function(id) {

	skin.isShow(id, true);

},

/**

 * 隐藏dom

 * @param  {string} id dom的id

 * @return {void}    无

 */

skin.hide = function(id) {

    skin.isShow(id, false);

},

/**

 * 是否显示

 * @return {bool} 返回布尔值

 */

skin.isShow = function(id, flag) {

    skin.g(id).style.display = flag ? 'block' : 'none';

},

/**

 * 添加样式

 * @param {string|object} element   目标元素

 * @param {string} className 样式名称

 */

skin.addClass = function(element, className) { 

	element = skin.g(element)||element;

    var classArray = className.split(/\s+/),

        result = element.className,

        classMatch = " " + result + " ",

        i = 0,

        l = classArray.length;



    for (; i < l; i++) {

         if ( classMatch.indexOf( " " + classArray[i] + " " ) < 0 ) {

             result += (result ? ' ' : '') + classArray[i];

         }

    }



    element.className = result;

},

/**

 * 移除样式

 * @param  {string|object} element   目标元素

 * @param  {string} className 样式名称

 * @return {void}           无

 */

skin.removeClass = function(element, className) { 

	element = skin.g(element)||element; 



    var oldClasses = element.className.split(/\s+/),

        newClasses = className.split(/\s+/),

        lenOld,

        lenDel = newClasses.length,

        j,

        i = 0;  

    for (; i < lenDel; ++i) {

        for(j = 0, lenOld = oldClasses.length; j < lenOld; ++j) {

            if (oldClasses[j] == newClasses[i]) {

            	oldClasses.splice(j, 1);

            	break;

            }

        }

    }

    element.className = oldClasses.join(' ');

},

/**

 * 设置字体

 * @param {int}   

 * @return void

 */

skin.setFontFamily = function (key) {   //设置字体:  0-宋体 ; 1-微软雅黑;

    key = key || 0;

    var obj = document.body;

    var font = ''; 

    if (key) {

        font = '"微软雅黑", "宋体", Arial, Verdana';

    } else {

        font = '"宋体", "微软雅黑", Arial, Verdana';

    }

    obj.style.fontFamily = font;

}

/**

 * 设置页面显示的字体(win7--雅黑字,其他为宋体)

 * @param 无

 * @return string

 */

skin.getSysver = function () {

    var key = 0;

    try {

        key = skin.execOrder('sysver');

        if ('6.1' == key) {

            key = 1;

        }

    } catch (e) {   }   

    

    skin.setFontFamily(key); 

},

/**

 * 设置存储值

 * @param {string} key   存储值

 * @param {string} value 存储内容

 */

skin.setConfig = function (key, value) {

    try{

        var globalData = getConfigData() || {};

        globalData[key] = value;

        var str = '{';

        var sp = '';



        for (k in globalData) {

            if ('{' != str) {

                sp =',';

            }

            str += sp + '"' + k + '":"' + globalData[k] + '"';

        }



        str += '}';

        try { 

             window.external.SyncRequest('saveConfig', str);

        } catch (e) {}   

    } catch(e) { }

},

/**

 * 获取存储值

 * @param  {string} key 存储值

 * @return {string}     对应内容

 */

skin.getConfig = function (key) { 

    try{

        var globalData = getConfigData();

        if (globalData && typeof globalData[key] != 'undefined') { 

            return globalData[key];

        }

    } catch(e) {  }

    return null;

},

/**

 * 获取本地存储

 * @return {object} 本地存储对象

 */

skin.getConfigData = function () {

    try {

        if (window.external.SyncRequest) {

            var strJSON = window.external.SyncRequest('readConfig'); 

            strJSON= jsonDecode(strJSON);

            return strJSON;

        }  

    } catch (e) {

         return null;

    }   

},

/**

 * 设置本地存储

 * @type {Object}

 */

skin.storage = {

    set: function (key, value) {

        this.data(key, value);

    },

    get: function (key) {  

        return this.data(key);

    },

    /**

     * 处理存储数据

     * @param  {string} key   存储(获取的)key

     * @param  {[type]} value 存储的值

     * @return {boolea | object}       操作结果

     */

    data: function (key, value) {

        var configData = ''; 

        if (!window.external.SyncRequest('readConfig') || window.external.SyncRequest('readConfig') == 0) {

            configData = '{"' + config.skinName + '": {}}';

        }        

        if (typeof configData == 'string') {

            configData = JSON.parse(configData);

        }

        if (value && value.length > 0) {

            configData[config.skinName][key] = value;

            skin.execOrder('saveConfig', configData.join(''));

            return true;

        } else {            

            return (configData.key || false);

        }

        return false;

    }

},

/**

 * 根据秒数获取格式后的时间

 * @param  {number} time 秒数

 * @return {string}      格式化后的时间字符串

 */

skin.getFormatTime = function (time) {    

    time = parseInt(time, 10);

    if (!time) {

        return '';

    }    

    var formatString = '';

    var days = Math.floor(time / 86400);

    formatString = (days)? days + '天' : '';

    time = time - (days * 86400);

    var hours = Math.floor(time / 3600);

    formatString += (formatString || hours)? hours+'小时':'';

    time = time - (hours * 3600);

    var minutes = Math.floor(time / 60);

    formatString += (formatString || minutes)? minutes + '分':'';

    seconds = time - (minutes * 60);

    formatString += (formatString || seconds)? seconds + '秒':'';

            

    return formatString;    

},

/**

 * 处理icon点击

 * @param  {event} e          事件

 * @param  {bool} rightClick 是否为右键(点击)

 * @param  {number} key        iconid

 * @return {void}            无

 */

skin.execMouseDown = function (e, rightClick, key) { 

    //取消冒泡事件

    e.stopPropagation(); 

    

    var order = rightClick ? 'mouseRDown' : 'mouseLDown';

    try {

        window.external.SyncRequest(order, key);

    } catch (e) {}  

},

/**

 * 处理右键点击

 * @param  {string} id elementid

 * @return {void}    无

 */

skin.rightButton = function (id) {

    if (event.button == 2) {

       skin.execMouseDown(event, true, id);

    }

},

/**

 * 执行命令

 * @param {string} 命令名称

 * @param {string} 值

 * @return string | void

 */

skin.execOrder = function (order, key) {  

    var info = '';

    try { 

        key = (key.length == 0 ? '0' : key); 

        info = window.external.SyncRequest(order, key);

    } catch (e) {}     

    return info;

},

/**

 * 执行客户端命令,获取参数

 * @param  {string} order 命令名称

 * @param  {string} param 参数

 * @return {void|object}       无|-

 */

skin.execSync = function (order, param) {

    try {

        if (window.external.SyncRequest) {

            return window.external.SyncRequest(order, param);

        } 

    } catch (e) {

        return '';

    }

    return '';

},

//获取RD数据status,null 时返回当前状态

/**

 * 设置icon状态

 * @param  {string} id  icon的id

 * @param  {string} key 命令

 * @return {void}     无

 */

skin.getExecStatus = function (id, key) {  

    if (typeof skin.g(id) == 'string') {

        return;

    }

    var statu = skin.execSync('getButtonState', key) || skin.g(id).getAttribute('statu'); 

    return statu;

},

/**

 * 初始输入法状态  

 * 参数:0 (中英文切换) 返回值: 0 英文 1 中文;

 * 参数:1 (全半角切换) 返回值: 0 半角 1 全角; 

 * 参数:2 (中英文标点) 返回值: 0 英文标点 1 中文标点;

 * 参数:3 (软键盘)

 * 参数:4 (登录)            返回值: 0 未登录 1 已登录

 * 参数:5 (配置)

 */

skin.setIMEStatus = function () { 

    setButtonState('0', skin.getExecStatus('language', '0'));    

    setButtonState('1', skin.getExecStatus('characters', '1'));  

    setButtonState('2', skin.getExecStatus('punctuation', '2')); 

    setButtonState('4', skin.getExecStatus('login', '4'));   

},

/**

 * 复制到剪贴板

 * @param  {string} copyText 要复制的文本

 * @return {void}          无

 */

skin.copyText = function (copyText) { 

    return skin.execOrder('copy', copyText);

},

/**

 * 绑定输入法icon点击/hover等事件

 * @return {void} 无

 */

skin.bindEvent = function () {

    var icons = skin.g('iconEvent').getElementsByTagName('img');

    for (var i = 0, len = icons.length; i < len; i++) {        

        icons[i].onclick = function () { 

            skin.execMouseDown(event, false, this.getAttribute('key'));

        }

        icons[i].onmouseup = function () { 

            skin.rightButton(this.getAttribute('key'));

        }

        icons[i].onmouseover = function () { 

            skin.execOrder('mouseOver', this.getAttribute('key'));

        }

        icons[i].onmouseout = function () { 

            skin.execOrder('mouseOver', 'null');

        }

    }

    document.onclick  =function () {

        skin.execMouseDown(event, false, 'null');    

    }


    document.onmouseup =function (e) {  
        skin.rightButton('null'); 

    }     
},

/**

 * 控制小手显示

 * @param {object} elementId 目标元素

 * @param {string} key       对应元素的key

 */

skin.setHover = function (element, key) {

    element.onmouseover = function () { 

        skin.execOrder('mouseOver', key);

    }

    element.onmouseout = function () { 

        skin.execOrder('mouseOver', 'null');

    }

},
/**
 * 获取日期
 * @return {number} 日期(20121209类似这样)
 */
skin.getDateCode = function () {
    var newDate = new Date(), 
        year = newDate.getFullYear();
        month =  newDate.getMonth() + 1,
        date = newDate.getDate();
    if (month < 10) {
        month = '0' + month;
    }
    if (date < 10) {
        date = '0' + date;
    }
    return parseInt('' + year + month + date);
},
/**

 * 设置皮肤动画

 */

skin.setAnimate = function () {   
    skin.playCount = 0; 
    skin.date = skin.getDateCode();    
    skin.proccesslimit();
    // 设置皮肤焦点

    skin.setHover(skin.g('getDiscount'), 'url');

    skin.setHover(skin.g('closeBox'), 'url');

    skin.setHover(skin.g('contact'), 'url');

    skin.setHover(skin.g('showDiscountList'), 'url');


    // 设置状态栏背景-节日    

    skin.bgIntervalSpeed = 30 * 60 * 1000;

    skin.date = parseInt(new Date().getDate());

    skin.getBackground();



    // 抢

    skin.getDiscount();

    skin.g('showDiscountList').onclick = function () {

        // 展示我的激活码

        if (this.getAttribute('statu') == '0') {

            skin.showUserDiscount();            

            this.setAttribute('statu', '1');

        } else {

            skin.closeBox('discountList');

            this.setAttribute('statu', '0');

        }  

    } 

    skin.g('domBox').onclick = function (e) {

        var obj = e.target; 

        if ('closeBox' == obj.id) { 

            if (obj.getAttribute('dialogType')) { 

                skin.closeBox(obj.getAttribute('dialogType'));

            }  

        } else if ('copyText' == obj.id) { 

            var result = skin.copyText(skin.textStream); 

            if (result == 'true') {  

                if (skin.copyBtnTimer) {

                    window.clearTimeout(skin.copyBtnTimer);

                    skin.copyBtnTimer = null;

                }               

                skin.addClass(obj.id,'succ-copy');

                skin.copyBtnTimer = window.setTimeout(function () {

                    skin.removeClass(obj.id, 'succ-copy');                    

                }, 300);             

            }            

        }   

    } 

},
/**
 * 更新记录时间
 * @return {void} 无
 */
skin.proccesslimit = function () {
    skin.limitStatu = 1;
    skin.limitTimer = window.setInterval(function () { 
        var date = new Date();            
        if (date.getHours() == 0 && skin.limitStatu == 1) {            
            skin.date = skin.getDateCode();
            skin.playCount = 0;
            skin.limitStatu = 0;            
        } else if (date.getHours() != 0) {
            skin.limitStatu = 1;
        }
    }, 60000);
},

/**

 * 每天2点后拉取节日图片

 * @return {void} 无

 */

skin.getBackground = function () {

    skin.processIMEBackground();

    skin.getBgInterval = window.setInterval(function () {

        // 每隔半小时判断时间是否到达2点--拉取图片

        if (parseInt(new Date().getHours()) == 2 ) {

            skin.processIMEBackground();                      

        }        

    }, skin.bgIntervalSpeed);

},

/**

 * 定时拉取背景图,直到成功为止

 * @return {void} 无

 */

skin.startGetBackgroud = function () {

    skin.getBackgroudInterval = window.setInterval(function () {

        skin.processIMEBackground();

    }, skin.bgIntervalSpeed);

},

/**

 * 提交到sign填写联系方式页面

 */

skin.setContactInfo = function () { 

    //var sign = skin.g('contact').getAttribute('sign') || '';  

    var sign = serverSignCode || '';

    var urlRedirect = skin.urlList.contactUrl + '?sign=' + sign + '&t=' + (+new Date());

    skin.execOrder('openURL', urlRedirect);    

},

/**

 * 显示我的福利(激活码)

 * @return {void} 无

 */

skin.showUserDiscount = function () {

    var fuliInfo = window.external.SyncRequest('readConfig') || '[]'; 

    if (typeof fuliInfo == 'string') {

        fuliInfo = JSON.parse(fuliInfo);

    }
	var isAlert = false;

    if (fuliInfo.length == 0) {
		isAlert = true;

        //return;

    }

    skin.buildDom('discountList', {list: fuliInfo, isAlert:isAlert});

},

skin.getDiscount = function () { 

    //'抢'定时动画

    window.setTimeout(function () {

        skin.addClass(skin.g('discount').getElementsByTagName('div')[0], 'discount-sway');

        window.setInterval(function () {           

            skin.g("discount").innerHTML = '<div class="btn-getdiscount  pos-abs discount-sway"></div>   ';

        }, 30000);

    }, 400);

    // 抢福利

    skin.g('getDiscount').onclick = function (e) {   

        skin.winId = '';    

        skin.rcode = ''; 

        skin.pccode = ''; 

        var closeBox = skin.g('closeBox');

        var status = ((typeof closeBox == 'string') ? '0' : closeBox.getAttribute('dialogStatu'));        

        
        // if ((skin.discountTimerStatus && skin.discountTimerStatus == 1)  || status == '1') {

        //     //请求未结束             

        //     return false;

        // } 

        skin.discountTimerStatus = 1;               

        skin.proccessPostCode();             

    }

},

/**

 * 重置skin.discountTimerStatus

 * 0-间隔时间结束

 * 1-响应中

 * 2-响应终止;

 * 3-响应结束

 */

skin.setDiscountTimer = function (status) {  

    if (typeof status != 'undefined') {

        skin.discountTimerStatus = status;

    }

},

/**

 * 获取随机码-抢

 * @return {void} 无

 */
skin.loadingTimmer = null;
skin.loadingDelay = 350;

skin.proccessPostCode = function () { 
	if(skin.loadingTimmer){
		return;
	}    
    
	skin.buildDom('empty');	
    
    if (skin.playCount && skin.playCount >= 3) { 
        skin.buildDom('limit', {});
        return false;
    }
    skin.playCount++;

    var pccode = skin.execOrder('GetToken', 'null'); 

    if (!pccode || pccode.length == 0) {

        return false;

    }

    skin.pccode = pccode;
	skin.showLoading(true);

    try {

        baidu.ajax.request(skin.urlList.codeUrl + '?t=' + (+new Date()),{ 

            method: 'POST',

            data: 'pccode=' + encodeURIComponent(skin.pccode),       

            timeout: 3000,

            onsuccess:function (xhr, result) {

                result = result || {}; 

                if(typeof result == 'string'){

                    result = JSON.parse(result);

                }               

                var status = ((typeof result.data.status) == 'undefined' ? 1 : result.data.status);
				skin.loadingTimmer = window.setTimeout(function(){
					skin.showLoading(false);
					switch (status) {
						case 0:
							// 可以抢  
							if (result.data.rcode) {
								skin.getDiscountData(result.data);  
							} else { 
								skin.buildDom('fail', {});                
								skin.setDiscountTimer(2);
							}        
							break;
						case 2:
							// 没有到时间
							skin.beforeDiscount(result.data.message);
							skin.setDiscountTimer(2);                      
							break;
						default:
							// 不能抢(1 或其他状态)
							skin.noDiscount(); 
							skin.setDiscountTimer(2);                   
							break;
					} 

					skin.loadingTimmer = null;
				}, skin.loadingDelay);              

            },

            onfailure: function () {
				skin.loadingTimmer = window.setTimeout(function(){
					skin.showLoading(false);

					skin.buildDom('fail', {});                

					skin.setDiscountTimer(2);

					skin.loadingTimmer = null;
				}, skin.loadingDelay);

            },

            ontimeout: function (xhr) {
				skin.loadingTimmer = window.setTimeout(function(){
					skin.showLoading(false);

					skin.buildDom('fail', {});                

					skin.setDiscountTimer(2);

					skin.loadingTimmer = null;
				}, skin.loadingDelay);

            }

        });

    } catch (e) {		
		skin.loadingTimmer = window.setTimeout(function(){
			skin.showLoading(false);

			skin.buildDom('fail', {});                

			skin.setDiscountTimer(2);

			skin.loadingTimmer = null;
		}, skin.loadingDelay);

    }    

},

/**

 * 不能抢(提示: 木有到时间)

 */

skin.noDiscount = function () {

    skin.buildDom('timer', {});

},

/**

 * 还没到时间(提示: n点再来)

 */

skin.beforeDiscount = function (message) {

    if (!message) {

        skin.noDiscount();

        return false;

    }

    var resultStatu = 'timer', 

        info = {};

    info.text = message;                  

    skin.buildDom(resultStatu, info);



},

/**

 * 获取福利

 * @return {void} 无

 */

skin.getDiscountData = function (data) { 

    if (!data.rcode) {

        skin.noDiscount();

        return false;

    }    

    // 获取加密

    skin.rcode = data.rcode; 

    var newCode = skin.execOrder('GetToken', skin.rcode);

    if (!newCode || newCode.length == 0) {

        skin.noDiscount();

        return false;

    }    

    try {

        baidu.ajax.request(skin.urlList.playUrl + '?t=' + (+new Date()),{

            method: 'POST',

            data: 'sign=' + encodeURIComponent(newCode),

            timeout: 3000,

            onsuccess:function (xhr, result) { 

                result = result || {};  

                if(typeof result == 'string'){

                    result = JSON.parse(result);

                }          

                if (result.data) {               

                    var seconds = parseInt(result.data.remaining);                

                    var resultStatu = 'fail'; 

                    var status = result.data.status; 

                    var winInfo = {}; 

                    switch(status) {                       

                        case 1: //奖

                            resultStatu = 'success';

                            serverSignCode = result.data.sign || result.data.prize.sign; 

                            winInfo = skin.processSuccess(result.data.prize, result.data.sign || result.data.prize.sign);                                                    

                            break;                      

                        default: // 未中奖(包括0:未中奖 以及其他非中奖状态)                            

                            resultStatu = 'fail'; 

                            serverSignCode = null;

                            break;

                    } 

                    skin.buildDom(resultStatu, winInfo);    

                    // 增加联系方式hover

                    if (winInfo.showLink) {

                        skin.setHover(skin.g('contact'), 'url');

                    }             

                } else {

                    skin.buildDom('fail', {});

                    serverSignCode = null;

                }                

                skin.setDiscountTimer(3);

            },

            onfailure: function () {            

                skin.buildDom('fail', {});                

                skin.setDiscountTimer(3);

                serverSignCode = null;

            },

            ontimeout: function (xhr) {            

                skin.buildDom('fail', {});                

                skin.setDiscountTimer(3);

                serverSignCode = null;

            }

        });

    } catch (e) {

        skin.buildDom('fail', {});

        skin.setDiscountTimer(3);

        serverSignCode = null;

    }

},

/**

 * 获取状态栏背景

 * @return {void} 无

 */

skin.processIMEBackground = function () {

    try {

        baidu.ajax.request(skin.urlList.imgBgUrl + '?t=' + (+new Date()),{        

            timeout: 3000,

            onsuccess:function (xhr, result) {

                result = result || {};

                if(typeof result == 'string'){

                    result = JSON.parse(result);

                }

                // 设置特定节日背景

                if (result.data.src) { 

                    // 取消尝试拉取

                    if(skin.getBackgroudInterval){

                        window.clearInterval(skin.getBackgroudInterval);

                        skin.getBackgroudInterval = null;

                    }

                    // 重置每天2点拉取

                    var speed = 31 * 60 * 1000;

                    if (skin.getBgInterval) {

                        window.clearInterval(skin.getBgInterval);

                        window.setTimeout(function () {

                            skin.getBackground();

                        }, speed);

                    }

                    

                    skin.g('imeStatu').style.backgroundImage = 'url(' + result.data.src + ')';  

                                      

                } 

            },

            onfailure: function () {

                if(!skin.getBackgroudInterval){

                    // 取消每天两点拉取

                    if (skin.getBgInterval) {

                        window.clearInterval(skin.getBgInterval);

                    }

                    skin.startGetBackgroud();

                }

            },

            ontimeout: function (xhr) {

                if(!skin.getBackgroudInterval){

                    // 取消每天两点拉取

                    if (skin.getBgInterval) {

                        window.clearInterval(skin.getBgInterval);

                    }

                    skin.startGetBackgroud();

                }

            }

        });

    } catch (e) {}    

},

/**

 * 处理中奖结果

 * @param  {object} data 中奖数据

 * @return {object}      处理后的中奖信息

 */

skin.processSuccess = function (data, sign) {

    if (!data) {

        return;

    } 

    var win = {};     

    if (data.virtual && parseInt(data.virtual) == 1) { //虚拟奖        

        win.title = data.name;

        win.text = data.vcode;

        win.date = data.expire_time;

        win.showLink = false; 

        // 存储我的激活码             

        var fuliInfo = window.external.SyncRequest('readConfig') || '[]';      

        fuliInfo= JSON.parse(fuliInfo);

        fuliInfo.push(win); 

        var fuliSkinInfo = JSON.stringify(fuliInfo) || '[]';    

        skin.execOrder('saveConfig', fuliSkinInfo);               

    } else { //实物奖        

        win.title = data.title;

        win.text = data.name;          

        win.showLink = true; 

        win.serverCode = sign;  



        skin.winId = data.id;

    }    

    return win;

}

/**

 * 关闭当前显示(获取当前dialog类型,调取config相应配置)

 * @param  {string} dialogType dialog类型

 * @return {void} 无

 */

skin.closeBox = function (dialogType) {

    var items = config.animations.slideDown[dialogType];       

    for (var i = 0, len = items.length; i < len; i++) {

        skin.addClass(skin.g(items[i].id), skin.g(items[i].className));

    }     

    if (dialogType == 'discountList') {

        skin.g("showDiscountList").setAttribute('statu', '0');

    } else {

        skin.g('closeBox').setAttribute('dialogStatu','0');

    } 

},

/**

 * 设置动画 

 * @param  {string} actionName 动画名称

 * @return {void}            无

 */

skin.animation = function (actionName, element, test) {  

    if (skin.animateName != "nomal" ) { 

        return;

    }

    actionName = actionName || 'nomal';

    skin.animateName = actionName;  



    var parent = g(element);

    skin.actionNode = parent;

    var action = rabbit.animations[actionName];

    parent.innerHTML = '';   



    var actionDom = createElement('div', action.className);

    parent.appendChild(actionDom);

    // 子节点

    if (action['childNode'] && action['childNode'].length > 0) {

        var child = null;

        for (var i = 0, len = action['childNode'].length; i < len; i++) {

            child = createElement('div', action.childNode[i]);

            actionDom.appendChild(child);

        }

    }    

    // 增加动画转变

    if (action['delay']) {

        var delay = action['delay']; 

        if (skin.timer) {

            clearTimeout(skin.timer);

        }

        skin.timer = window.setTimeout(function () {        

            addClass(skin.actionNode.getElementsByTagName('div')[delay.num], delay.className);  

            

            if (action.duration > 0) {

                skin.cancelAnimate(action.duration * 2);

            }            

        }, delay.time);           

        

    } else {

        if (action.duration > 0) {

            skin.cancelAnimate(action.duration);

        }   

    }      

},

/**

 * 清空动画特效

 * @param  {number} duration 特效执行时间

 * @return {void}          无

 */

skin.cancelAnimate = function (duration) { 

    window.clearTimeout(skin.cancelTimer);

    skin.cancelTimer = window.setTimeout(function () {  

        skin.animateName = 'nomal';       

        skin.animation('nomal', 'action');                

    }, duration); 

},

skin.process = {

    success: function (param) { 

        skin.html = [];       

        if (param.showLink) {

            skin.html[skin.html.length] = '<div id="successTitle" class="pos-abs success-title succ-link success-title-slideup">'; 

            skin.html[skin.html.length] = '     <div id="contact" onclick="skin.setContactInfo()" sign="' + (param.serverCode || '') +'" class="contact pos-abs pointer"></div>';

        } else {

            skin.html[skin.html.length] = '<div id="successTitle" class="pos-abs success-title success-title-slideup">'; 

            skin.textStream = '';

            skin.textStream = skin.textStream + '\r\n' + param.title + '\r\n' + param.text;

        }        

        skin.html[skin.html.length] = '     <p class="longText">' + config.prizeTitle + param.title + '</p>  ';                                         

        skin.html[skin.html.length] = '     <div id="successBarTitle" class="pos-abs bar bar-succ-title-up bar-succ-title-up"></div> ';    

        skin.html[skin.html.length] = '</div> ';             

        skin.html[skin.html.length] = '<div id="successText" class="pos-abs success-text success-text-slideup' + (param.showLink ? ' copy' : '') + '">';

        skin.html[skin.html.length] = '     <p class="longText">' + param.text + '</p>';

        skin.html[skin.html.length] = '     <div id="copyText" copy="1" class="pos-abs btn-copy pointer"></div>';

        skin.html[skin.html.length] = '     <div id="closeBox" dialogStatu="1" dialogType="success" class="pos-abs close pointer"></div>';

        skin.html[skin.html.length] = '     <div id="successBarText" class="pos-abs bar bar-succ-title-up bar-succ-text-up"></div> ';                 

        skin.html[skin.html.length] = '</div>';

    },

    fail: function () {

        skin.html = [];

        skin.html[skin.html.length] = '<div id="failText" class="fail pos-abs fail-slideup">';

        skin.html[skin.html.length] = '     <div id="closeBox" dialogStatu="0" dialogType="fail" class="pos-abs pointer close fail-close"></div>';

        skin.html[skin.html.length] = '     <div id="failBarText" class="pos-abs bar bar-succ-title-up bar-fail-up"></div>';

        skin.html[skin.html.length] = '</div>';

    },

    timer: function (param) {

        var timerClass = '';

        if (!param.text) {

            timerClass = 'timer-none';

        }

        skin.html = [];

        skin.html[skin.html.length] = '<div id="timerText" class="timer ' + timerClass + ' pos-abs timer-slideup">';

        if (timerClass.length == 0) { 

            skin.html[skin.html.length] = '     <p class="timer-warn pos-abs">' + param.text + '</p>';

        }

        skin.html[skin.html.length] = '     <div id="timerBarText" class="pos-abs bar bar-succ-title-up bar-timer-up"></div>';

        skin.html[skin.html.length] = '     <div id="closeBox" dialogStatu="1" dialogType="timer" class="pos-abs pointer close fail-close timer-close"></div>';

        skin.html[skin.html.length] = '<div';

    },

    discountList: function (params) {
		var list = params.list;
		var isAlert = params.isAlert;

        skin.textStream = '';

        skin.html = [];

        skin.html[skin.html.length] = '<div id="userDiscount" class="user-discount pos-abs user-slideup">';

        skin.html[skin.html.length] = '   <div class="pos-abs items">';

        skin.html[skin.html.length] = '    <div id="itemsBox" class="pos-abs items-box">';

        skin.html[skin.html.length] = '        <ul>';
		if(!isAlert){

			for (var i = list.length - 1; i >= 0; i--) {

				 skin.html[skin.html.length] = '   <li>' + list[i].title + '</li>';

				 skin.html[skin.html.length] = '   <li class="bg">' + list[i].text + '</li>';

				 skin.html[skin.html.length] = '   <li class="bg-date">' + list[i].date + '</li>';

				 skin.textStream = skin.textStream + list[i].title + '\r\n' + list[i].text + '\r\n' + list[i].date + '\r\n';

			}
		}else{
			 skin.html[skin.html.length] = '   <li>' + config.noPrizeText + '</li>';
			 skin.textStream = '';
		}

        skin.html[skin.html.length] = '         </ul>';                         

        skin.html[skin.html.length] = '     </div>';

        skin.html[skin.html.length] = '    </div>';

        skin.html[skin.html.length] = '    <div id="closeBox" dialogStatu="0" dialogType="discountList" class="pos-abs user-discount-close pointer"></div>';
		if(!isAlert){

			skin.html[skin.html.length] = '    <div id="copyText" copy="all" class="pos-abs btn-copy pointer"></div>';
		}

        skin.html[skin.html.length] = '</div>';

    },
	empty: function(){
        skin.textStream = '';
        skin.html = [];
	},
    limit: function () {
        skin.html = [];

        skin.html[skin.html.length] = '<div id="limit" class="timer limit pos-abs timer-slideup">';

        skin.html[skin.html.length] = '     <div id="timerBarText" class="pos-abs bar bar-succ-title-up bar-timer-up"></div>';

        skin.html[skin.html.length] = '     <div id="closeBox" dialogStatu="0" dialogType="limit" class="pos-abs pointer close fail-close timer-close"></div>';

        skin.html[skin.html.length] = '<div';
    }
},

/**

 * 显示相应模块

 * @param  {string} domType 模块名称

 * @param  {object} param   显示数据(json)

 * @return {void}         无

 */

skin.buildDom = function (domType, param) { 

    if (typeof skin.process[domType] == 'function') { 

        if (typeof skin.g('closeBox') == 'object') { 

            skin.closeBox(skin.g('closeBox').getAttribute('dialogType'));

        }

        skin.process[domType](param);

        var html = skin.html.join('');

        skin.g('domBox').innerHTML = html;

        if (domType == 'discountList') {

            skin.g("showDiscountList").setAttribute('statu', '1');

        }

    }    

}

/**
* 向server请求数据时,显示loading效果
* @param {boolean} isShow 是否显示loading
*/
skin.showLoading = function(isShow){
	isShow ? skin.show(config.loadingDomId) : skin.hide(config.loadingDomId);
}

/**

 * 打印日志

 * @param {string} str 要打印的东西

 */

function Log(str) {   

    try {

        if(window.external.SyncRequest) { 

            window.external.SyncRequest('log', str);

        } else {            

            // console.log(str);

        }

    } catch (e) {}

}

// 供客户端调用

function setButtonState(key, statu) { 

    var status = config.buttonstatus;

    var id = '';

    key = key || '0';

    id = status[key].id;

    if (typeof skin.g(id) == 'string') {

        return;

    }

    statu =  statu || (skin.g(id).getAttribute('statu') == '0' ? '1' : '0');     

    skin.g(id).src = 'images/icons/' + status[key][statu];

    skin.g(id).setAttribute ('statu', statu);        

}







